leetcode hot100 215. 数组中的第K个最大元素 medium 堆 快速选择 pivot分区


找第K大元素

暴力解法:排序后取第K个

时间复杂度:O(nlog⁡n)O(n \log n)O(nlogn),取决于排序算法(如快排、归并排序)

空间复杂度:O(1)O(1)O(1) 或 O(n)O(n)O(n),取决于排序实现

python 复制代码
class Solution:
    def findKthLargest(self, nums: List[int], k: int) -> int:
        nums.sort() # 暴力排序
        print(nums)   # 从小到大
        return nums[-k]

快速选择(Quick Select)算法

平均时间复杂度:O(n)

  1. 每次划分大约把数组分成两半,递归只进入一边。
  2. 平均递归深度约为 log n,但每层只处理部分数组,所以平均时间复杂度是 O(n)。

最坏情况:O(n²)(但可通过随机化 pivot 避免)

空间复杂度:O(1)(原地修改数组)

class中自己调自己,用self.

python 复制代码
class Solution:
    def findKthLargest(self, nums: List[int], k: int) -> int:

        # 快速选择(数组在无序状态下,每次抛一半: O(n))(二分法是有序状态下每次抛一半 O(log n))

        # 1. 随机选择一个分组参考值
        center = nums[-1]

        # 2. 分成3个部分
        left = [x for x in nums if x > center]  # 值大于center的
        mid  = [x for x in nums if x == center]  # 值 = center的
        right  = [x for x in nums if x < center]  # 值 < center的

        # 3. 判断 第k大 所在部分
        if k <= len(left):   # 值大于center的个数,超过k个,说明k在左边
            return self.findKthLargest(left,k)  # class中自己调自己,用self.
        elif k <= len(left)+ len(mid): # 第k大的值就=center值,而且可能还有好几个相同值
            return center
        else:  # 在右边
            return self.findKthLargest(right, k-len(left)-len(mid))
相关推荐
Nil2086 小时前
leetcode 763划分字母区间
算法·leetcode·职场和发展
不会就选b6 小时前
算法日常・每日刷题--<动态规划>20
算法·leetcode·动态规划
不会就选b7 小时前
算法日常・每日刷题--<动态规划>19
算法·leetcode·职场和发展
垆边人似月.9 小时前
华为机试题 :和为 K 的子数组个数
算法·leetcode·华为
夏幻灵10 小时前
每日一题:LeetCode 165:比较版本号
算法·leetcode·职场和发展
Navigator_Z10 小时前
LeetCode //C - 1288. Remove Covered Intervals
c语言·算法·leetcode
0+11111 小时前
算法 --链表
数据结构·算法·leetcode·链表
圣保罗的大教堂11 小时前
leetcode 2333. 最小差值平方和 中等
leetcode
Nil20816 小时前
leetcode 300最长递增子序列
算法·leetcode·职场和发展
yi01117 小时前
LeetCode 424. 替换后的最长重复字符|不定长滑动窗口:如何判断窗口是否合法?
笔记·python·算法·leetcode·双指针·滑动窗口